import { HistoryAction, ILocation, IPartialLocation } from '@propulse/app';
import { ActionType as TSActionType } from 'typesafe-actions';
export declare enum InternalAppActionType {
    HISTORY_LOCATION_CHANGE = "@@router/HISTORY_LOCATION_CHANGE"
}
export declare enum AppActionType {
    PUSH = "@@router/PUSH",
    GO = "@@router/GO",
    RESET = "@@router/RESET",
    GO_BACK = "@@router/GO_BACK",
    GO_FORWARD = "@@router/GO_FORWARD",
    REPLACE = "@@router/REPLACE",
    REMOVE = "@@router/REMOVE"
}
export declare const historyLocationChange: (historyKey: string, action: HistoryAction, index: number, entries: ILocation<any>[], length: number, location: ILocation<any>, callback?: (() => any) | undefined) => {
    type: InternalAppActionType;
    payload: {
        historyKey: string;
        action: HistoryAction;
        index: number;
        entries: ILocation<any>[];
        length: number;
        location: ILocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const push: (routerKey: string, location: string | IPartialLocation<any>, callback?: (() => any) | undefined) => {
    type: AppActionType.PUSH;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const go: (routerKey: string, n: number, callback?: (() => any) | undefined) => {
    type: AppActionType.GO;
    payload: {
        routerKey: string;
        n: number;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const reset: (routerKey: string, entries: (string | IPartialLocation<any>)[], index?: number | undefined, callback?: (() => any) | undefined) => {
    type: AppActionType.RESET;
    payload: {
        routerKey: string;
        entries: (string | IPartialLocation<any>)[];
        index: number | undefined;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const goBack: (routerKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.GO_BACK;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const goForward: (routerKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.GO_FORWARD;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const replace: (routerKey: string, location: string | IPartialLocation<any>, callback?: (() => any) | undefined) => {
    type: AppActionType.REPLACE;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare const remove: (routerKey: string, locationKey: string, callback?: (() => any) | undefined) => {
    type: AppActionType.REMOVE;
    payload: {
        routerKey: string;
        locationKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
};
export declare type InternalAppAction = TSActionType<{
    historyLocationChange: typeof historyLocationChange;
}>;
export declare type AppAction = TSActionType<{
    push: typeof push;
    go: typeof go;
    reset: typeof reset;
    goBack: typeof goBack;
    goForward: typeof goForward;
    replace: typeof replace;
    remove: typeof remove;
}>;
