import { action as tsAction } from 'typesafe-actions';
export var InternalAppActionType;
(function (InternalAppActionType) {
    InternalAppActionType["HISTORY_LOCATION_CHANGE"] = "@@router/HISTORY_LOCATION_CHANGE";
})(InternalAppActionType || (InternalAppActionType = {}));
export var AppActionType;
(function (AppActionType) {
    AppActionType["PUSH"] = "@@router/PUSH";
    AppActionType["GO"] = "@@router/GO";
    AppActionType["RESET"] = "@@router/RESET";
    AppActionType["GO_BACK"] = "@@router/GO_BACK";
    AppActionType["GO_FORWARD"] = "@@router/GO_FORWARD";
    AppActionType["REPLACE"] = "@@router/REPLACE";
    AppActionType["REMOVE"] = "@@router/REMOVE";
})(AppActionType || (AppActionType = {}));
export const historyLocationChange = (historyKey, action, index, entries, length, location, callback) => tsAction(InternalAppActionType.HISTORY_LOCATION_CHANGE, { historyKey, action, index, entries, length, location }, { callback });
export const push = (routerKey, location, callback) => tsAction(AppActionType.PUSH, { routerKey, location }, { callback });
export const go = (routerKey, n, callback) => tsAction(AppActionType.GO, { routerKey, n }, { callback });
export const reset = (routerKey, entries, index, callback) => tsAction(AppActionType.RESET, { routerKey, entries, index }, { callback });
export const goBack = (routerKey, callback) => tsAction(AppActionType.GO_BACK, { routerKey }, { callback });
export const goForward = (routerKey, callback) => tsAction(AppActionType.GO_FORWARD, { routerKey }, { callback });
export const replace = (routerKey, location, callback) => tsAction(AppActionType.REPLACE, { routerKey, location }, { callback });
export const remove = (routerKey, locationKey, callback) => tsAction(AppActionType.REMOVE, { routerKey, locationKey }, { callback });
