/// <reference types="react" />
import { IApp } from '@propulse/app';
import { AnyAction } from 'redux';
import { SerializedHistory } from './utils';
export declare type AppState = {
    histories: {
        [key: string]: SerializedHistory;
    };
};
export declare const appStateKey = "@@app";
export interface IAppEnhancedWithRedux extends IApp {
    readonly _context: {
        reactContainers: React.ComponentType[];
        reduxMiddlewares: Array<(app: IAppEnhancedWithRedux, action: AnyAction) => void>;
        [key: string]: any;
    };
}
export { AppActionType, push, go, reset, goBack, goForward, replace, AppAction } from './actions';
export { ConnectedAppContainerProps, ConnectedAppContainer } from './ConnectedAppContainer';
export { appMiddleware } from './middleware';
export { createAppReducer } from './reducer';
export { combineAppReducer } from './combineAppReducer';
export { serializeHistory, SerializedHistory } from './utils';
