import { IApp, IPartialLocation } from '@propulse/app';
import { AnyAction, Dispatch } from 'redux';
import { AppActionType } from '../actions';
export declare function appMiddleware(app: IApp): () => (next: Dispatch<AnyAction>) => (action: {
    type: AppActionType.PUSH;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO;
    payload: {
        routerKey: string;
        n: number;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.RESET;
    payload: {
        routerKey: string;
        entries: (string | IPartialLocation<any>)[];
        index: number | undefined;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO_BACK;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.GO_FORWARD;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.REPLACE;
    payload: {
        routerKey: string;
        location: string | IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: AppActionType.REMOVE;
    payload: {
        routerKey: string;
        locationKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
}) => undefined;
