import { AppActionType } from '../actions';
export function appMiddleware(app) {
    return () => (next) => (action) => {
        switch (action.type) {
            case AppActionType.PUSH:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].push(action.payload
                        .location);
                }
                return;
            case AppActionType.GO:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].go(action.payload.n);
                }
                return;
            case AppActionType.RESET:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].reset(action.payload
                        .entries);
                }
                return;
            case AppActionType.GO_BACK:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].goBack();
                }
                return;
            case AppActionType.GO_FORWARD:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].goForward();
                }
                return;
            case AppActionType.REPLACE:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].replace(action.payload
                        .location);
                }
                return;
            case AppActionType.REMOVE:
                if (app.histories[action.payload.routerKey]) {
                    app.histories[action.payload.routerKey].remove(action.payload.locationKey);
                }
                return;
        }
        const extensionMiddlewares = typeof app._context.reduxMiddlewares === 'object' &&
            Array.isArray(app._context.reduxMiddlewares)
            ? app._context.reduxMiddlewares
            : undefined;
        if (extensionMiddlewares) {
            const len = extensionMiddlewares.length;
            for (let i = 0; i < len; ++i) {
                extensionMiddlewares[i](app, action);
            }
        }
        return next(action);
    };
}
