import { AppState } from '..';
import { InternalAppActionType } from '../actions';
export declare function createAppReducer(initialState: AppState): (state: AppState | undefined, action: {
    type: InternalAppActionType;
    payload: {
        historyKey: string;
        action: import("@propulse/app").HistoryAction;
        index: number;
        entries: import("@propulse/app").ILocation<any>[];
        length: number;
        location: import("@propulse/app").ILocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.PUSH;
    payload: {
        routerKey: string;
        location: string | import("@propulse/app").IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.GO;
    payload: {
        routerKey: string;
        n: number;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.RESET;
    payload: {
        routerKey: string;
        entries: (string | import("@propulse/app").IPartialLocation<any>)[];
        index: number | undefined;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.GO_BACK;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.GO_FORWARD;
    payload: {
        routerKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.REPLACE;
    payload: {
        routerKey: string;
        location: string | import("@propulse/app").IPartialLocation<any>;
    };
    meta: {
        callback: (() => any) | undefined;
    };
} | {
    type: import("..").AppActionType.REMOVE;
    payload: {
        routerKey: string;
        locationKey: string;
    };
    meta: {
        callback: (() => any) | undefined;
    };
}) => AppState;
